#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>

#define BLOCKSIZE (4096)

void
check(char *buffer, int value)
{
    int bad = 0;
    int *p = (int *) buffer;
    for (int i = 0; i < (BLOCKSIZE / sizeof(int)); i++) {
	if (*p != value) 
	    bad++;
    }
    if (bad)
	fprintf(stderr, "BAD BLOCK: value should be %d but wasn't\n", value);
}

int main(int argc, char *argv[])
{
    if (argc != 4) {
	fprintf(stderr, "usage: lcheck <filename> <start> <num blocks>\n"); exit(1);
    } 
    char *file	= argv[1];
    int start	= atoi(argv[2]);
    int end		= atoi(argv[3]);
    
    int fd = open(file, O_RDONLY);
    char buffer[BLOCKSIZE];	
    int i;
    int rc = 1;
    
    lseek(fd, start * BLOCKSIZE, SEEK_SET);
    for(i = start; i <= end && rc > 0; i++) {
		rc = read(fd, buffer, BLOCKSIZE); 
		if(rc > 0) {
			check(buffer, i);
		}
    }
    
    if(rc == -1 && errno == EIO) {
    	fprintf(stderr, "error reading file block %d\n", (i - 1));
    }
    
    (void) close(fd);
    
    return 0;
}

