#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <assert.h>
#include <errno.h>

#define BLOCKSIZE (4096)

int main(int argc, char *argv[])
{	int rc;
	int type;
		    
	switch(argc) {
		case 3:
			type = 0;
			break;
    	case 4:
    		type = 1;
    		break;
    	default:
    		fprintf(stderr, "usage: trunc <filename> <size in blocks> <f>\n");
    		exit(1);
    		break;
	} 
    
    char *file	= argv[1];
    int size	= atoi(argv[2]) * BLOCKSIZE;
    
    if(type == 0) {
    	rc = truncate(file, size);
    	if(rc != 0) { perror("error: truncate"); }
    	assert(rc == 0);
    } else {
    	int fd = open(file, O_WRONLY);
    	rc = ftruncate(fd, size);
    	if(rc != 0) { perror("error: ftruncate"); }
    	close(fd);
    }
    
    return 0;
}

