#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <assert.h>

#define BLOCKSIZE (4096)

void
fill(char *buffer, int value)
{    int *p = (int *) buffer;
    for (int i = 0; i < (BLOCKSIZE / sizeof(int)); i++) {
	*p = value;
	p++;
    }
}

int main(int argc, char *argv[])
{
    if (argc != 4) {
	fprintf(stderr, "usage: write <filename> <start> <end>\n"); exit(1);
    } 
    
    char *file = argv[1];
    int start  = atoi(argv[2]);
    int end  = atoi(argv[3]);
    
    int fd = open(file, O_WRONLY); assert(fd > -1);
    int rc = lseek(fd, start * BLOCKSIZE, SEEK_SET);
    assert(rc == (start * BLOCKSIZE));
    
    for (int i = start; i < end; i++) {
		char buffer[BLOCKSIZE];
		fill(buffer, i);
		rc = write(fd, buffer, BLOCKSIZE);
		assert(rc == BLOCKSIZE);
    }
    (void) close(fd);
    
    return 0;
}

